//Copyright 2005 Tijmen van gulik
//Distributed on an as is basis. Apache License, Version 2.0
//http://www.apache.org/licenses/LICENSE-2.0
unit FormMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ExtDlgs, Menus, StdCtrls, ComCtrls, BrwsFldr, Grids,
  ValEdit, Buttons,Contnrs, FileOp;

type
  TPropertyValue = class
  public
    sFile : string;
    sSection : string;
    sKey : string;
    sValueType : string;
    sDescripton : string;
    sDefaultValue : string;
    oColor : TColor;
    oDefaultColor : TColor;
    bSystem  : Boolean;
    bRequired : boolean;
    sValue : string;
    constructor Create;
  end;
  TfrmMain = class(TForm)
    OpenPictureDialog1: TOpenPictureDialog;
    pcWizardSteps: TPageControl;
    tabFileSelection: TTabSheet;
    pnControlBar: TPanel;
    tabSelectArea: TTabSheet;
    pnTop: TPanel;
    laFileSelectionDesc1: TLabel;
    laFileSelectionDesc2: TLabel;
    laFileSelectionImageFile: TLabel;
    edFileName: TEdit;
    pbChooseFile: TBitBtn;
    Panel1: TPanel;
    Panel2: TPanel;
    oImagePreview: TImage;
    Panel3: TPanel;
    Label4: TLabel;
    tabSelectSkinn: TTabSheet;
    laChooseSkinFolder: TLabel;
    edFolder: TEdit;
    pbSelectFolder: TBitBtn;
    laSelectSkinDescription: TLabel;
    laSkinName: TLabel;
    edSkinName: TEdit;
    BrowseForFolder1: TBrowseForFolder;
    tabProcess: TTabSheet;
    Panel5: TPanel;
    laProcessing: TLabel;
    edLog: TMemo;
    cbHideLeftAppViewBorder: TCheckBox;
    pnSelectAreaScrollBox: TScrollBox;
    oPreview: TImage;
    tabSkinProperties: TTabSheet;
    oPropertyList: TValueListEditor;
    cmbTemplates: TComboBox;
    laTemplate: TLabel;
    pnCommandRight: TPanel;
    pbNext: TBitBtn;
    pbBack: TBitBtn;
    pnSkinPropertiesImage: TPanel;
    laSkinPropertiesImage: TLabel;
    oSelectColor: TColorDialog;
    oSetColorPreviewPic: TImage;
    pbSelectColor: TPopupMenu;
    mnuSelectColor: TMenuItem;
    pbClear: TMenuItem;
    edSkinDescripton: TEdit;
    edSkinAutor: TEdit;
    edBasedOnText: TEdit;
    laDescription: TLabel;
    laAuthor: TLabel;
    laBasedOn: TLabel;
    pnSkinProperties: TPanel;
    laSkinProperties: TLabel;
    pnFinished: TPanel;
    laProcessing1: TLabel;
    laSkinDir: TLabel;
    tabWarning: TTabSheet;
    tabChooseWhatToDo: TTabSheet;
    rbChooseNewSkin: TRadioButton;
    rbRecompileSkin: TRadioButton;
    laChooseDescription: TLabel;
    pnChooseSkinFolder: TPanel;
    laSkinFolder: TLabel;
    edRecalcSkinFolder: TEdit;
    pbRecalcSkin: TBitBtn;
    laChooseLocateFolder: TLabel;
    pbRestart: TBitBtn;
    laProcessing2: TLabel;
    Label20: TLabel;
    laProcessing3: TLabel;
    laProcessing4: TLabel;
    laSourceDir: TLabel;
    laProcessing5: TLabel;
    Label24: TLabel;
    pbAbout: TBitBtn;
    Panel4: TPanel;
    imgWizard: TImage;
    Panel6: TPanel;
    edWarning: TMemo;
    pnWaringBottomPanel: TPanel;
    cbWarning: TCheckBox;
    laImageQuality: TLabel;
    cmImageQuality: TComboBox;
    laBits: TLabel;
    cmImageQuality2: TComboBox;
    Label1: TLabel;
    oCopy: TFileOperation;
    laExplainRecompile: TLabel;
    laSkininfoText: TLabel;
    laAndSkinInfoText: TLabel;
    procedure mnuLoadClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure pbNextClick(Sender: TObject);
    procedure pbBackClick(Sender: TObject);
    procedure pbSelectFolderClick(Sender: TObject);
    procedure oPreviewMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure oPreviewMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure oPropertyListEditButtonClick(Sender: TObject);
    procedure oSetColorPreviewPicMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure mnuSelectColorClick(Sender: TObject);
    procedure pbClearClick(Sender: TObject);
    procedure oPropertyListDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure rbRecompileSkinClick(Sender: TObject);
    procedure rbChooseNewSkinClick(Sender: TObject);
    procedure pbRestartClick(Sender: TObject);
    procedure pbRecalcSkinClick(Sender: TObject);
    procedure StartLinkClick(Sender: TObject);
    procedure pbAboutClick(Sender: TObject);
    procedure pbSelectColorPopup(Sender: TObject);
    procedure cmImageQuality2Change(Sender: TObject);
    procedure cmImageQualityChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    oSource : TBitMap;

    sMainDir : string;
    sSkinDir : string;
    sBMPDir : string;
    sMBMDir : string;
    sMBMDirName : string;
    sSkinFile : string;
    sTemplateDir : string;
    sTemplatesDir : string;
    sQuality : string;
    iSelectOldX : integer;
    iSelectOldY : integer;
    iLastSelectX : integer;
    iLastSelectY : integer;
    lstTemplates : TStrings;
    slPropertyValues : TObjectList;
    slColorSections : TStrings;
    sDefaultColorsDir : string;

    function FindPopertyValue(sFile,sSection,sKey : string;var iRow : integer) : TPropertyValue;
    procedure FillTemplateCombo;
    procedure DrawSelector(iX,iY : integer;bSelected : boolean);
    procedure Finish;
    procedure CreatePreview;
    procedure InitSelectSkin;
    procedure Process;
    procedure SetDirectiroyVars;
    procedure CreateDirectoryStructure;
    procedure CreateBMPs;
    procedure CreateMBMs;
    procedure CopyToSource;
    procedure SaveProperies;
    procedure InitDefaultSkinProperties;
    procedure LoadChangedSkinProperties(sDir : string);
    procedure SetRowPropertiesListColor(iRow : integer;oColor : TColor);
    procedure EnableDisableComponents;
    procedure InitChooseWhatToDo;
  end;

var
  frmMain: TfrmMain;

implementation

uses Clipbrd,Jpeg,Utilities,Math,DialogAbout,IniFiles;

{$R *.dfm}

const sKEY_TITLE_BORDER_COLOR = 'KEY_TITLE_BORDER_COLOR';
      iDEFAULT_QUALITY_INDEX = 1; //Note second item i

constructor TPropertyValue.Create;
begin
  inherited;
  oColor:=clNone;
  bSystem:=False;
  bRequired:=False;
end;

function ReadSkinFileProperty(sLine: string; var sKey,sDefaultValue,sDescription : string;var Color : TColor) : boolean;
var slValues : TStrings;
    iLastPos,i : integer;
    bSpaceZone : boolean;
begin
  Result:=True;
  if (trim(sLine)='') or (copy(sLine,1,2)='//') then sKey:='' //skipp empty lines
  else if copy(sLine,1,1)='[' then Result:=False //The end
  else
  begin
    slValues :=TStringList.Create;
    slValues.Delimiter:=#9;
    try
      try
        slValues.Clear;
        iLastPos:=1;
        bSpaceZone:=False;
        for i:=1 to Length(sLine) do
        begin
          if slValues.Count<5 then
          begin
            if (sLine[i]=' ') or (sLine[i]=#9) then
            begin
              if not bSpaceZone then
              begin
                slValues.Add(Copy(sLine,iLastPos,i-iLastPos));
                bSpaceZone:=True;
              end
            end
            else if bSpaceZone then
            begin
              bSpaceZone:=False;
              iLastPos:=i;
            end;
          end;
        end;
        slValues[slValues.Count-1]:=Copy(sLine,iLastPos,Length(sLine));
        if slValues.Count<3 then raise exception.Create('Line to short')
        else
        begin
          sKey:=slValues[0];
          sDefaultValue:=slValues[1]+' '+slValues[2]+' '+slValues[3];
          if slValues.Count<=3 then sDescription:=''
          else sDescription:=slValues[4];
          if Copy(sDescription,1,2)='//' then
            sDescription:=sDescription+Copy(sDescription,3,Length(sDescription));
          Color:=StrToIntDef(slValues[1],0)  +(StrToIntDef(slValues[2],0) shl 8 )	+(StrToIntDef(slValues[3],0) shl 16);
        end;
      except
        raise exception.Create(Format('Inccorrect skin property line in template %s',[sLine]));
      end;
    finally
      slValues.Free;
    end;
  end;
end;

function FindKeyInPropertyList(slSkinTextFile : TStrings;iStartFrom : integer; sKey : string;var iPostion :integer) : boolean;
var sFoundKey,sDefaultValue,sDescription : string;
    Color : TColor;
    i : integer;
begin
  Result:=False;
  iPostion:=iStartFrom;
  for i:=iStartFrom to slSkinTextFile.Count-1 do
  begin
    if not ReadSkinFileProperty(slSkinTextFile[i],sFoundKey,sDefaultValue,sDescription, Color) then
      Break;
    if sFoundKey<>'' then iPostion:=i;
    if lowercase(sKey)=lowercase(sFoundKey) then
    begin
      Result:=True;
      Break;
    end;
  end;

end;

procedure SetPropertyInSkinFile(slSkinTextFile : TStrings;oValue: TPropertyValue);
var iHeaderIndex : integer;
    iPostion : integer;
    sLine : string;
    iColor : integer;
begin
  iHeaderIndex:=findLowerCaseListValue(slSkinTextFile,'['+oValue.sSection+']',True);
  iColor:=ColorToRGB(oValue.oColor);
  sLine:=oValue.sKey+#9+
         IntToStr((iColor ) and $FF)+#9+
         IntToStr((iColor shr 8) and $FF)+#9+
         IntToStr((iColor shr 16) and $FF)+#9+
         '//'+oValue.sDescripton;
  if FindKeyInPropertyList(slSkinTextFile,iHeaderIndex+1,oValue.sKey,iPostion) then
  begin
     if oValue.sValue='' then slSkinTextFile.Delete(iPostion)
     else slSkinTextFile[iPostion]:=sLine
  end
  else
  begin
    if oValue.sValue<>'' then
    begin
      //Not found, insert at end
      if iPostion>=slSkinTextFile.Count then slSkinTextFile.Append(sLine)
      else slSkinTextFile.Insert(iPostion,sLine);
    end;
  end;
end;

procedure TfrmMain.mnuLoadClick(Sender: TObject);
var oJPG : TJPEGImage;
    sExtention : string;
begin
  if OpenPictureDialog1.Execute then
  begin
     sExtention:=lowercase(ExtractFileExt(OpenPictureDialog1.FileName));
     //sPath:=ExtractFilePath(OpenPictureDialog1.FileName);
     if (sExtention='jpg') or (sExtention='jpeg') then
     begin
       oJPG:=TJPEGImage.Create;
       try
         oJPG.LoadFromFile(OpenPictureDialog1.FileName);
         oImagePreview.Picture.Assign(oJPG);
       finally
         oJPG.Free;
       end;
     end
     else
       oImagePreview.Picture.LoadFromFile(OpenPictureDialog1.FileName);
     edFileName.Text:=OpenPictureDialog1.FileName;
  end;

end;

procedure TfrmMain.FormCreate(Sender: TObject);
var i : integer;
    oColorConfig : TIniFile;
begin
  oSource :=TBitMap.Create;
  oSource.Width:=755;
  oSource.Height:=200;

  for i:=0 to pcWizardSteps.PageCount-1 do
    pcWizardSteps.Pages[i].TabVisible:=False;
  pcWizardSteps.ActivePage:=tabWarning;
  sTemplatesDir:=ExtractFilePath(Application.ExeName)+'Templates';
  lstTemplates :=TStringList.Create;
  slPropertyValues :=TObjectList.Create;
  sQuality:=cmImageQuality.Items[iDEFAULT_QUALITY_INDEX];
  EnableDisableComponents;
  sDefaultColorsDir:=ExtractFilePath(Application.ExeName)+'DefaultColors';
  oColorConfig:=TIniFile.Create(sDefaultColorsDir+'\Config.ini');
  slColorSections:=TStringList.Create;
  try
    oColorConfig.ReadSectionValues('color_sections',slColorSections);
  finally
    oColorConfig.Free;
  end;
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  oSource.Free;
  lstTemplates.Free;
  slPropertyValues.Free;
  slColorSections.Free;

end;

procedure TfrmMain.DrawSelector(iX,iY : integer;bSelected : boolean);
begin
   if iX+755>oPreview.Picture.Width then iX:=oPreview.Picture.Width-755;
   if iY+200>oPreview.Picture.Height then iY:=oPreview.Picture.Height-200;
   with oPreview.Canvas do
   begin
     Brush.Color:=clNone;
     Brush.Style:= bsClear;
     Pen.Color:=clWhite;
     Pen.Mode:=pmNot;
     if bSelected then Pen.Style:=psSolid
     else Pen.Style:= psDot;
     Rectangle(iX,iY,iX+755,iY+200);
     MoveTo(iX+32,iY+0);
     LineTo(iX+32,iY+200);
     MoveTo(iX+92,iY+0);
     LineTo(iX+92,iY+200);
     MoveTo(iX+555,iY+0);
     LineTo(iX+555,iY+200);
     MoveTo(iX+92,iY+6);
     LineTo(iX+555,iY+6);
     MoveTo(iX+0,iY+100);
     LineTo(iX+92,iY+100);

     MoveTo(iX+92,iY+33);
     LineTo(iX+640+92,iY+33);
     MoveTo(iX+640+92,iY+33);
     LineTo(iX+640+92,iY+0);

     MoveTo(iX+640,iY+0);
     LineTo(iX+640,iY+200);
//     MoveTo(iX+555+200,iY+0);
//     LineTo(iX+555+200,iY+200);

   end;
end;

procedure TfrmMain.CreatePreview;
var oStreched : TBitMap;
const   oRect : TRect = (Left:0; Top:0; Right:755; Bottom:200);

begin
   //Now stretch the picture to 640 200
 oStreched :=TBitMap.Create;
 try
   oStreched.PixelFormat:=pf32bit;
   oStreched.Width:=Max(755,oImagePreview.Picture.Width);
   oStreched.Height:=Max(200,oImagePreview.Picture.Height);
   oRect.Right:=oStreched.Width;
   oRect.Bottom:= oStreched.Height;
   oStreched.Canvas.StretchDraw(oRect,oImagePreview.Picture.Graphic);
   oPreview.Picture.Assign(oStreched);
   oPreview.Width:=oPreview.Picture.Width;
   oPreview.Height:=oPreview.Picture.Height;
   iSelectOldX:=-1;
   iSelectOldY:=-1;
   iLastSelectX:=0;
   iLastSelectY:=0;
   CopyToSource;
   DrawSelector(0,0,True);
  finally
    oStreched.Free;
  end;
end;

procedure TfrmMain.pbNextClick(Sender: TObject);
var bContinue : Boolean;
    iPage : integer;
begin
  if pcWizardSteps.ActivePageIndex=tabProcess.PageIndex then Close
  else
  begin
    bContinue:=True;
    iPage:=pcWizardSteps.ActivePageIndex+1;
    if pcWizardSteps.ActivePageIndex=tabWarning.PageIndex then
    begin
      bContinue:=cbWarning.Checked;
      if bContinue then InitChooseWhatToDo;
    end
    else if pcWizardSteps.ActivePageIndex=tabChooseWhatToDo.PageIndex then
    begin
      bContinue:=rbChooseNewSkin.Checked or
                 (edRecalcSkinFolder.Text<>'');
      if rbRecompileSkin.Checked then
      begin
        SetDirectiroyVars;
        InitDefaultSkinProperties;
        LoadChangedSkinProperties(sMBMDir);
        iPage:=tabSkinProperties.PageIndex;
      end;
    end
    else if iPage=tabSelectArea.PageIndex then
    begin
      bContinue:=edFileName.Text<>'';
      if bContinue then CreatePreview;
    end
    else if iPage=tabSelectSkinn.PageIndex then
       InitSelectSkin
    else if iPage=tabSkinProperties.PageIndex then
    begin
       bContinue:=(cmbTemplates.ItemIndex>=0) and
                  (Trim(edSkinName.Text)<>'') and
                  (Trim(edFolder.Text)<>'');

       if bContinue then
       begin
         InitDefaultSkinProperties;
         //Load from the template
         LoadChangedSkinProperties(sTemplateDir+'\Skin\'+sMBMDirName);
       end;
    end;
    if bContinue then
    begin
      pcWizardSteps.ActivePageIndex:=iPage;
      EnableDisableComponents;
      if iPage=tabProcess.PageIndex then
         Process;
    end;
  end;
end;



procedure TfrmMain.pbBackClick(Sender: TObject);
begin
  if rbRecompileSkin.Checked and
     (pcWizardSteps.ActivePage=tabSkinProperties) then
  begin
    pcWizardSteps.ActivePage:=tabChooseWhatToDo;
    EnableDisableComponents;
  end
  else
  begin
    if  pcWizardSteps.ActivePageIndex>0 then
      pcWizardSteps.ActivePageIndex:=pcWizardSteps.ActivePageIndex-1;
  end;
  EnableDisableComponents;
end;

procedure TfrmMain.Finish;
begin
  pnFinished.Visible:=True;
  laSkinDir.Caption:=sMainDir+'\'+edSkinName.Text;
  laSourceDir.Caption:=sBMPDir;
end;


procedure TfrmMain.pbSelectFolderClick(Sender: TObject);
begin
  BrowseForFolder1.Path:=ExtractFilePath(OpenPictureDialog1.FileName);
  if BrowseForFolder1.Execute then
    edFolder.Text:=BrowseForFolder1.Path;
end;

procedure TfrmMain.CreateBMPs;
var  oNew : TBitMap;
const RectWallpaperSource : TRect    = (Left:92; Top:6; Right:555; Bottom:200);
      RectWallpaperDest : TRect      = (Left:0; Top:0; Right:463; Bottom:194);
      RectSkinapptitleSource  : TRect  = (Left:92; Top:0; Right:732; Bottom:200);
      RectSkinapptitleDest  : TRect  = (Left:0; Top:0; Right:640; Bottom:200);
      RectCommandbarSource : TRect   = (Left:555; Top:0; Right:755; Bottom:200);
      RectCommandbarDest : TRect     = (Left:0; Top:0; Right:200; Bottom:200);
      RectAppView_Small_Left : TRect =  (Left:0; Top:0; Right:32; Bottom:200);
      RectAppView_Small_Top : TRect  =  (Left:0; Top:0; Right:640; Bottom:34);
      RectAppView_Large_Left : TRect =  (Left:0; Top:0; Right:92; Bottom:200);
      RectAppView_Large_Top : TRect  =  (Left:0; Top:0; Right:640; Bottom:33);
      RectAppView_8 : TRect          =  (Left:0; Top:0; Right:92; Bottom:100);
      RectPowerDesk_Desk_Source  : TRect = (Left:92; Top:0; Right:640; Bottom:200);
      RectPowerDesk_Desk_Dest    : TRect = (Left:0; Top:0; Right:548; Bottom:200);
      RectPowerDesk_Today_Source : TRect = (Left:32; Top:0; Right:640; Bottom:200);
      RectPowerDesk_Today_Dest   : TRect = (Left:0; Top:0; Right:608; Bottom:200);
begin
 if cbHideLeftAppViewBorder.Checked then
 begin
   RectAppView_Small_Left.Right:=RectAppView_Small_Left.Right+1;
   RectAppView_Large_Left.Right:=RectAppView_Large_Left.Right+1;
   RectAppView_8.Right:=RectAppView_8.Right+1;
 end;
  edLog.Lines.Add('Create BMP files');
  //Save the
   //Now stretch the picture to 640 200
 oNew :=TBitMap.Create;
 try

   //Copy the wall paper and save it
   oNew.PixelFormat:=pf24bit;
   oNew.Width:=463;
   oNew.Height:=194;
   oNew.Canvas.CopyRect(RectWallpaperDest,oSource.Canvas,RectWallpaperSource);
   oNew.SaveToFile(sSkinDir+'\WallPaper.bmp');

   //Now create all the template
   oNew.PixelFormat:=pf24bit;
   oNew.Width:=548;
   oNew.Height:=200;
   oNew.Canvas.CopyRect(RectPowerDesk_Desk_Dest,oSource.Canvas,RectPowerDesk_Desk_Source);
   oNew.SaveToFile(sSkinDir+'\Powerdesk_desk.bmp');

   //Now create all the template
   oNew.PixelFormat:=pf24bit ;
   oNew.Width:=608;
   oNew.Height:=200;
   oNew.Canvas.CopyRect(RectPowerDesk_Today_Dest,oSource.Canvas,RectPowerDesk_Today_Source);
   oNew.SaveToFile(sSkinDir+'\Powerdesk_Today.bmp');

    //Now do the  skinapptitle which is an exact copy of the source
   oNew.ReleaseHandle;
   oNew.Width:=640;
   oNew.Height:=200;
   oNew.Canvas.CopyRect(RectSkinapptitleDest,oSource.Canvas,RectSkinapptitleSource);
   oNew.SaveToFile(sBMPDir+'\skinapptitle\5.bmp');

   oNew.ReleaseHandle;
   oNew.Width:=1;
   oNew.Height:=1;
//   oNew.Canvas.Pixels[0,0]:=FindPopertyValue(sKEY_TITLE_BORDER_COLOR).oColor;
   //does not mater wich color images will be overwriten by skinapptitle 5
   oNew.SaveToFile(sBMPDir+'\skinapptitle\1.bmp');
   oNew.SaveToFile(sBMPDir+'\skinapptitle\2.bmp');
   oNew.SaveToFile(sBMPDir+'\skinapptitle\3.bmp');
   oNew.SaveToFile(sBMPDir+'\skinapptitle\4.bmp');
   oNew.SaveToFile(sBMPDir+'\skinapptitle\6.bmp');
   oNew.SaveToFile(sBMPDir+'\skinapptitle\7.bmp');
   oNew.SaveToFile(sBMPDir+'\skinapptitle\8.bmp');
   oNew.SaveToFile(sBMPDir+'\skinapptitle\9.bmp');
   oNew.SaveToFile(sBMPDir+'\skinapptitle\10.bmp');

   //Copy the skin commandbar
   oNew.ReleaseHandle;
   oNew.Width:=200;
   oNew.Height:=200;
   oNew.Canvas.CopyRect(RectCommandbarDest,oSource.Canvas,RectCommandbarSource);

   oNew.SaveToFile(sBMPDir+'\skincommandbar\1.bmp');
   oNew.SaveToFile(sBMPDir+'\skincommandbar\2.bmp');
   oNew.SaveToFile(sBMPDir+'\skincommandbar\3.bmp');

   //Now do the skinappview
   oNew.ReleaseHandle;
   oNew.Width:=640;
   oNew.Height:=200;
   oNew.Canvas.CopyRect(RectAppView_Small_Left,oSource.Canvas,RectAppView_Small_Left);
   oNew.Canvas.CopyRect(RectAppView_Small_Top,oSource.Canvas,RectAppView_Small_Top);
   oNew.SaveToFile(sBMPDir+'\skinappview\1.bmp');
   oNew.SaveToFile(sBMPDir+'\skinappview\2.bmp');
   oNew.SaveToFile(sBMPDir+'\skinappview\4.bmp');
   oNew.Canvas.CopyRect(RectAppView_Large_Left,oSource.Canvas,RectAppView_Large_Left);
   oNew.SaveToFile(sBMPDir+'\skinappview\3.bmp');
   oNew.ReleaseHandle;

   oNew.Width:=92;
   if cbHideLeftAppViewBorder.Checked then oNew.Width:=oNew.Width+1;
   oNew.Height:=100;
   oNew.Canvas.CopyRect(RectAppView_8,oSource.Canvas,RectAppView_8);
   oNew.SaveToFile(sBMPDir+'\skinappview\9.bmp');
 finally
   oNew.Free;
 end;
end;

procedure TfrmMain.CreateDirectoryStructure;
begin
  //Create the directory structure and the applications
  edLog.Lines.Add('Create directory structure');

  ForceDirectories(sSkinDir);
  ForceDirectories(sBMPDir);

  //Copy The files
//Xopy often crashes, so use an other copy method  
//  ShellExecute_Simple('xcopy',' /S /Y /E "'+sTemplateDir+'\Skin'+'" "'+sSkinDir+'"','',False);
//  ShellExecute_Simple('xcopy',' /S /Y /E "'+sTemplateDir+'\Source'+'" "'+sBMPDir+'"','',False);
  oCopy.FilesFrom:= sTemplateDir+'\Skin\*.*';
  oCopy.FilesTo:=sSkinDir;
  oCopy.Execute;
  oCopy.FilesFrom:= sTemplateDir+'\Source\*.*';
  oCopy.FilesTo:=sBMPDir;
  oCopy.Execute;

end;

procedure TfrmMain.Process;
begin
  pnFinished.Visible:=False;
  Screen.Cursor:=crHourGlass;
  pbNext.Enabled:=False;
  try
    edLog.Lines.Clear;
    if rbChooseNewSkin.Checked then
    begin
      CreateDirectoryStructure;
      CreateBMPs;
      CreateMBMs;
      SaveProperies;
    end
    else
    begin
      SaveProperies;
      CreateMBMs;
    end;
    edLog.Lines.Add('Done');
  finally
    Screen.Cursor:=crDefault;
    pbNext.Enabled:=True;
  end;
  Finish;
end;

procedure TfrmMain.CreateMBMs;
var
  sr: TSearchRec;
  slBatchFile : TStrings;
  sLogFile ,sBatchFileName : string;

  function AddToCommadList(iNr : integer;sMBMFileName,sa_Quality : string;var sListOfFiles : string) : boolean;
  begin
    Result:=FileExists(sBMPDir+'\'+sMBMFileName+'\'+IntToStr(iNr)+'.bmp"');
    if Result then  sListOfFiles:=sListOfFiles+' "/'+sa_Quality+sBMPDir+'\'+sMBMFileName+'\'+IntToStr(iNr)+'.bmp"';

  end;
  procedure CreateMBMFile(sMBMFileName : string);
  var sListOfFiles : string;
      i : integer;
  begin
    sListOfFiles:='';
    if Lowercase(sMBMFileName)='skinapptitle' then
    begin
      //To hide the title line the main picture must be on top of the list
      AddToCommadList(5,sMBMFileName,'c'+sQuality,sListOfFiles);
      for i:=1 to 10 do
       if i<>5 then  AddToCommadList(i,sMBMFileName,'1',sListOfFiles);
    end
    else
    begin
      i:=1;
      while AddToCommadList(i,sMBMFileName,'c'+sQuality,sListOfFiles) do
      begin
        Inc(i);
      end;  //
    end;
    slBatchFile.Add('"'+ExtractFilePath(Application.ExeName)+'Utilities\bmconv.exe"'+
       ' /q "'+sMBMDir+'\'+sMBMFileName+'.mbm" '+sListOfFiles+' >>"'+sLogFile+'"');
  end;

begin
  edLog.Lines.Add('Create MBM files');
  sLogFile:=sBMPDir+'\log.txt';
  slBatchFile :=TStringList.Create;
  try
    if FindFirst(sBMPDir+'\*', faDirectory, sr) = 0 then
    repeat
      if  (sr.Name<>'.')  and (sr.Name<>'..') and  DirectoryExists(sBMPDir+'\'+sr.Name) then
        CreateMBMFile(sr.Name);
    until FindNext(sr) <> 0;
    FindClose(sr);
    sBatchFileName:=sBMPDir+'\MakeMbmFromBMP.bat';
    SysUtils.DeleteFile(sLogFile);
    slBatchFile.SaveToFile(sBatchFileName);
    ShellExecute_Simple(sBatchFileName,'','',false);
    //Re-use the log file stinglist for the error
    if FileExists(sLogFile) then
    begin
      slBatchFile.LoadFromFile(sLogFile);
      edLog.Lines.AddStrings(slBatchFile);
    end;
    SysUtils.DeleteFile(sLogFile);
  finally
    slBatchFile.Free;
  end;
end;

procedure TfrmMain.SetDirectiroyVars;
var sDirName : string;
    iPos : integer;
    oTemplateConfig : TIniFile;
    slSkinTextFile : TStrings;
begin
  if rbRecompileSkin.Checked then
  begin
    sMainDir:=edRecalcSkinFolder.Text;
    sDirName:=ExtractFileName(edRecalcSkinFolder.Text);
    iPos:=Pos('_',sDirName);
    if iPos<=0 then raise exception.create('Missing "_" in directory name, you can not rename the skin directory. It is also possible that you have selected the wrong directory.');
    edSkinName.Text:= Copy( sDirName,iPos+1,Length(sDirName));
    slSkinTextFile:=TStringList.Create;
    try
      LoadFromWideStringFile(sMainDir+'\'+edSkinName.Text+'\skinpath.txt',slSkinTextFile);
      if slSkinTextFile.Count<1 then raise exception.Create('skinpath.txt is empty');
      sMBMDirName:=ExtractFileDir(slSkinTextFile[0]);
      sMBMDirName:=Copy(sMBMDirName,Pos('\0x',sMBMDirName)+1,Length(sMBMDirName));
      sSkinFile:= ExtractFileName(slSkinTextFile[0]);
    finally
      slSkinTextFile.Text;
    end;
  end
  else
  begin
    sMainDir:=edFolder.Text+'\Skinn_'+edSkinName.Text;
    sTemplateDir:=ExtractFilePath(Application.ExeName)+'Templates\'+lstTemplates[cmbTemplates.ItemIndex];
    oTemplateConfig:=TIniFile.Create(sTemplateDir+'\Config.ini');
    try
      sMBMDirName:= oTemplateConfig.ReadString('Config','SkinDirectory','');
      sSkinFile:=oTemplateConfig.ReadString('Config','SkinFile','');
    except
      oTemplateConfig.Free;
    end;
  end;  

  sSkinDir:=sMainDir+'\'+edSkinName.Text;
  sBMPDir:=sMainDir+'\Source';
  sMBMDir:=sSkinDir+'\'+sMBMDirName;
end;

procedure TfrmMain.InitSelectSkin;
begin
  FillTemplateCombo;
  cmImageQuality.ItemIndex:=iDEFAULT_QUALITY_INDEX;
end;

procedure TfrmMain.oPreviewMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if (iSelectOldX<>-1) and  (iSelectOldY<>-1) then DrawSelector(iSelectOldX,iSelectOldY,False);
  DrawSelector(X,Y,False);
  iSelectOldX:=X;
  iSelectOldY:=Y;
end;

procedure TfrmMain.oPreviewMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  //errase old
  DrawSelector(iLastSelectX,iLastSelectY,True);
  DrawSelector(X,Y,False);
  iLastSelectX:=X;
  iLastSelectY:=Y;
  CopyToSource;
  //Draw the new selction
  DrawSelector(X,Y,True);
//  DrawSelector(X,Y);
  iSelectOldX:=-1;
  iSelectOldY:=-1;
end;

procedure TfrmMain.CopyToSource;
var RectSource : TRect;
const    RectDest : TRect    = (Left:0; Top:0; Right:755; Bottom:200);
begin
  RectSource.Left:= iLastSelectX;
  RectSource.Top:=  iLastSelectY;
  RectSource.Right:= iLastSelectX+755;
  RectSource.Bottom:= iLastSelectY+200;
  oSource.Canvas.CopyRect(RectDest,oPreview.Canvas,RectSource)
end;

procedure TfrmMain.FillTemplateCombo;
var  sr: TSearchRec;
     oConfig : TIniFile;
begin
  if FindFirst(sTemplatesDir+'\*', faDirectory, sr) = 0 then
  repeat
    if  (sr.Name<>'.')  and (sr.Name<>'..') and  DirectoryExists(sTemplatesDir+'\'+sr.Name)  then
    begin
      lstTemplates.Add(sr.Name);
      oConfig :=TIniFile.Create(sTemplatesDir+'\'+sr.Name+'\Config.ini');
      try
        cmbTemplates.Items.Add(sr.Name+' ('+oConfig.ReadString('Config','Description','')+')');
      finally
        oConfig.Free;
      end;
    end;
  until FindNext(sr) <> 0;
  cmbTemplates.ItemIndex:=0;
end;


procedure TfrmMain.InitDefaultSkinProperties;
var slProperties,slSectionNames : TStrings;
    slProperty : TStrings;
    iRow : integer;
    oPropertyValue : TPropertyValue;
    iSkinFile : integer;
    sCurrentSkinFileName,sSectionName : string;
    sKey,sDescription : string;
    Color : TColor;
    iSection,iSectionStartIndex,iPropertyPostition : integer;
    sValue : string;
begin
  SetDirectiroyVars;
  if slPropertyValues.Count=0 then
  begin
    if rbRecompileSkin.Checked then oSetColorPreviewPic.Picture.LoadFromFile(sBMPDir+'\skinapptitle\5.bmp')
    else oSetColorPreviewPic.Picture.Assign(oSource);

    try
      slProperty :=TStringList.Create;
      slProperties :=TStringList.Create;
      slSectionNames:=TStringList.Create;
      slPropertyValues.Clear;
      try
        //Insert system properties
{        oPropertyValue :=TPropertyValue.Create;
        oPropertyValue.bSystem:=True;
        oPropertyValue.bRequired:=True;
        slPropertyValues.Add(oPropertyValue);
        oPropertyValue.sKey:=sKEY_TITLE_BORDER_COLOR;
        oPropertyValue.sValueType:='color';
        oPropertyValue.sDescripton:='Title border color (background color of image skinapptitle.bmp)';
        oPropertyValue.oColor:=oSource.Canvas.Pixels[93,0];
        iRow:=oPropertyList.InsertRow(sKEY_TITLE_BORDER_COLOR,
                                    oPropertyValue.sDefaultValue,
                                    True)-1;
        oPropertyList.ItemProps[iRow].KeyDesc:=oPropertyValue.sDescripton;
        oPropertyList.ItemProps[iRow].EditStyle:=esEllipsis;
        oPropertyList.ItemProps[iRow].ReadOnly:=True;  }

        for iSkinFile:=0 to slColorSections.Count-1 do
        begin
          sCurrentSkinFileName:= slColorSections.Names[iSkinFile];
          slSectionNames.CommaText:=slColorSections.values[sCurrentSkinFileName];
          LoadFromWideStringFile(sDefaultColorsDir+'\'+sCurrentSkinFileName,slProperties);
          if Lowercase(sCurrentSkinFileName)='skin.skn' then
              sCurrentSkinFileName:=sSkinFile;
          for iSection :=0 to slSectionNames.Count-1 do
          begin
            sSectionName:= slSectionNames[iSection];
            iSectionStartIndex:=findLowerCaseListValue(slProperties,'['+sSectionName+']',True);
            iPropertyPostition:=iSectionStartIndex+1;
            while (iPropertyPostition<slProperties.Count) and
                  ReadSkinFileProperty(slProperties[iPropertyPostition],sKey,sValue,sDescription,Color) do
            begin
              if sKey<>'' then
              begin
                oPropertyValue :=TPropertyValue.Create;
                slPropertyValues.Add(oPropertyValue);
                oPropertyValue.sFile:=sCurrentSkinFileName;
                oPropertyValue.sSection:=sSectionName;
                oPropertyValue.sKey:=sKey;
                oPropertyValue.sValueType:='color';
                oPropertyValue.sDescripton:=sDescription;
                oPropertyValue.sDefaultValue:= sValue;
                oPropertyValue.sValue:= '';
                oPropertyValue.oColor:=Color;
                oPropertyValue.oDefaultColor:=Color;
                iRow:=oPropertyList.InsertRow(oPropertyValue.sSection+'_'+oPropertyValue.sKey,
                                        '',
                                        True)-1;
                oPropertyList.ItemProps[iRow].KeyDesc:=oPropertyValue.sKey+' '+oPropertyValue.sDescripton;
                oPropertyList.ItemProps[iRow].EditStyle:=esEllipsis;
                oPropertyList.ItemProps[iRow].ReadOnly:=True;
              end;
              Inc(iPropertyPostition);
            end;
          end;
        end;
      finally
        slProperties.Free;
        slProperty.Free;
        slSectionNames.Free;
      end;
   except
     on e : exception do
       raise exception.Create(Format('Error in reading the skin properties from the template configuration file, %s',[e.message]));
   end;
  end;
end;

procedure TfrmMain.LoadChangedSkinProperties(sDir : string);
var slProperties,slSectionNames : TStrings;
    slProperty : TStrings;
    iRow : integer;
    oPropertyValue : TPropertyValue;
    iSkinFile : integer;
    sCurrentSkinFileName,sSectionName,sFile : string;
    sKey,sDescription : string;
    Color : TColor;
    iSection,iSectionStartIndex,iPropertyPostition : integer;
    sValue : string;
begin
    //oSetColorPreviewPic.LoadFromFile();
    try
      slProperty :=TStringList.Create;
      slProperties :=TStringList.Create;
      slSectionNames:=TStringList.Create;
      try
        for iSkinFile:=0 to slColorSections.Count-1 do
        begin
          sCurrentSkinFileName:= slColorSections.Names[iSkinFile];
          slSectionNames.CommaText:=slColorSections.values[sCurrentSkinFileName];
          if Lowercase(sCurrentSkinFileName)='skin.skn' then
              sCurrentSkinFileName:=sSkinFile;
          sFile:= sDir+'\'+sCurrentSkinFileName;
          if FileExists(sFile) then
          begin
            for iSection :=0 to slSectionNames.Count-1 do
            begin
              sSectionName:= slSectionNames[iSection];
              LoadFromWideStringFile(sFile,slProperties);
              iSectionStartIndex:=findLowerCaseListValue(slProperties,'['+sSectionName+']',True);
              iPropertyPostition:=iSectionStartIndex+1;
              while (iPropertyPostition<slProperties.Count) and
                    ReadSkinFileProperty(slProperties[iPropertyPostition],sKey,sValue,sDescription,Color) do
              begin
                if sKey<>'' then
                begin
                  oPropertyValue:=FindPopertyValue(sCurrentSkinFileName,sSectionName,sKey,iRow);
                  if Assigned(oPropertyValue) then
                    SetRowPropertiesListColor(iRow,Color);
                end;
                Inc(iPropertyPostition);
              end;
            end;
          end;
        end;
      finally
        slProperties.Free;
        slProperty.Free;
        slSectionNames.Free;
      end;
   except
     on e : exception do
       raise exception.Create(Format('Error in reading the skin properties from the saved configuration, %s',[e.message]));
   end;
end;

procedure TfrmMain.oPropertyListEditButtonClick(Sender: TObject);
var oPoint : TPoint;
begin
  oPoint:=Mouse.CursorPos;
  pbSelectColor.Popup(oPoint.X,oPoint.Y);
end;

procedure TfrmMain.oSetColorPreviewPicMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  SetRowPropertiesListColor(oPropertyList.Row,oSetColorPreviewPic.Canvas.Pixels[X,Y]);
end;

procedure TfrmMain.SetRowPropertiesListColor(iRow : integer;oColor: TColor);
var iColor : LongInt;
begin
  if (oPropertyList.Col>=0) and  (iRow>=1) then
  begin
     if oColor=TPropertyValue(slPropertyValues[iRow-1]).oDefaultColor then
        oColor:=clNone;
     TPropertyValue(slPropertyValues[iRow-1]).oColor:=oColor;
     if oColor=clNone then
        oPropertyList.Cells[oPropertyList.Col,iRow]:=''
     else
     begin
       iColor:=ColorToRGB(oColor);
       oPropertyList.Cells[oPropertyList.Col,iRow]:=
          IntToStr((iColor ) and $FF)+' '+IntToStr((iColor shr 8) and $FF)+' '+IntToStr((iColor shr 16) and $FF);
     end;
     TPropertyValue(slPropertyValues[iRow-1]).sValue:=oPropertyList.Cells[oPropertyList.Col,iRow];
  end;
end;

procedure TfrmMain.mnuSelectColorClick(Sender: TObject);
var oColor : TColor;
begin
  oColor:=TPropertyValue(slPropertyValues[oPropertyList.Row-1]).oColor;
  if oColor<>clNone then
    oSelectColor.Color:=oColor;
  if oSelectColor.Execute then
      SetRowPropertiesListColor(oPropertyList.Row,oSelectColor.Color);
end;

procedure TfrmMain.pbClearClick(Sender: TObject);
begin
  SetRowPropertiesListColor(oPropertyList.Row,clNone);
end;

{ TPropertyValue }



procedure TfrmMain.SaveProperies;
var iRow : integer;
    slSkinTextFile : TStrings;
    oValue : TPropertyValue;
    sSkinFileName,sOldSkinFile,sActiveSkinFileName,sListLoadedFileName : string;
    iHeaderIndex : integer;
begin
  slSkinTextFile:=nil;
  try
    edLog.Lines.Add('Save skin properties');
    sSkinFileName:=sMBMDir+'\'+sSkinFile;
    slSkinTextFile :=TStringList.Create;
    LoadFromWideStringFile(sSkinFileName,slSkinTextFile);
    if rbChooseNewSkin.Checked then
    begin
      iHeaderIndex:=findLowerCaseListValue(slSkinTextFile,'[name]',True);
      slSkinTextFile[iHeaderIndex+1]:='"'+edSkinName.Text+'"';
      iHeaderIndex:=findLowerCaseListValue(slSkinTextFile,'[copyright]',True);
      slSkinTextFile[iHeaderIndex+1]:='"'+edSkinDescripton.Text+'"';
      slSkinTextFile[iHeaderIndex+2]:='"'+edSkinAutor.Text+'"';
      slSkinTextFile[iHeaderIndex+3]:='"'+edBasedOnText.Text+'"';
    end;
    sOldSkinFile:= '';
    sListLoadedFileName:=sSkinFileName;
    for iRow:=1  to oPropertyList.RowCount-1 do
    begin
      oValue:=TPropertyValue(slPropertyValues[iRow-1]);
      if  not oValue.bSystem then
      begin
        sActiveSkinFileName:=oValue.sFile;
        if sOldSkinFile<>sActiveSkinFileName then
        begin
          SaveToWideStringFile(sListLoadedFileName,slSkinTextFile);
          sOldSkinFile:=sActiveSkinFileName;

          if sActiveSkinFileName='' then  sListLoadedFileName:=sSkinFileName
          else sListLoadedFileName:=sMBMDir+'\'+sActiveSkinFileName;

          LoadFromWideStringFile(sListLoadedFileName,slSkinTextFile)
        end;
        SetPropertyInSkinFile(slSkinTextFile,oValue);
      end;
    end;
    SaveToWideStringFile(sListLoadedFileName,slSkinTextFile);

  finally
    slSkinTextFile.Free;
  end;
end;

procedure TfrmMain.oPropertyListDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var oColor : TColor;
begin
  if (ACol=0) and (ARow>0) and (ARow<=slPropertyValues.Count) then
  begin
    oColor:=TPropertyValue(slPropertyValues[ARow-1]).oColor;
    if oColor=clNone then oColor:=TPropertyValue(slPropertyValues[ARow-1]).oDefaultColor;
    if oColor<>clNone then
    begin
      oPropertyList.Canvas.Brush.Color:=oColor;
      oPropertyList.Canvas.Pen.Color:=clNone;
      oPropertyList.Canvas.Rectangle(Rect.Right-40,Rect.Top+2,Rect.Right-1,Rect.Bottom-2);
    end;
  end;
end;

procedure TfrmMain.rbRecompileSkinClick(Sender: TObject);
begin
  pnChooseSkinFolder.Visible:=True;
end;

procedure TfrmMain.rbChooseNewSkinClick(Sender: TObject);
begin
  pnChooseSkinFolder.Visible:=False;
end;

procedure TfrmMain.pbRestartClick(Sender: TObject);
begin
  pcWizardSteps.ActivePage:=tabChooseWhatToDo;
  EnableDisableComponents;
end;

procedure TfrmMain.pbRecalcSkinClick(Sender: TObject);
begin
  BrowseForFolder1.Path:=edRecalcSkinFolder.Text;
  if BrowseForFolder1.Execute then
    edRecalcSkinFolder.Text:=BrowseForFolder1.Path;
end;

procedure TfrmMain.EnableDisableComponents;
begin
//  pbRestart.Visible:= pcWizardSteps.ActivePage=tabProcess;
  pbBack.Visible:= pcWizardSteps.ActivePage<>tabWarning;
  if pcWizardSteps.ActivePage=tabProcess then
     pbNext.Caption:='Finish'
  else
    pbNext.Caption:='Next';
  pnFinished.Visible:=False;
end;

procedure TfrmMain.StartLinkClick(Sender: TObject);
begin
   if Copy(TLabel(Sender).Caption,1,4)='http' then
     ShellExecuteDirect_Simple( 'iexplore', '"'+TLabel(Sender).Caption+'"', '',False)
   else
     ShellExecuteDirect_Simple( 'explorer', '"'+TLabel(Sender).Caption+'"', '',False)

end;

procedure TfrmMain.pbAboutClick(Sender: TObject);
begin
  dlgAbout:=TdlgAbout.Create(self);
  try
    dlgAbout.ShowModal;
  finally
    dlgAbout.Free;
  end;
end;

procedure TfrmMain.pbSelectColorPopup(Sender: TObject);
begin
  pbClear.Enabled :=not TPropertyValue(slPropertyValues[oPropertyList.Row-1]).bRequired;
end;

function TfrmMain.FindPopertyValue(sFile,sSection,sKey : string;var iRow : integer): TPropertyValue;
var i : integer;
begin
  Result:=nil;
  sKey:=LowerCase(sKey);
  sSection:=LowerCase(sSection);
  sFile:=LowerCase(sFile);
  for i:=0 to slPropertyValues.Count-1 do
    if (LowerCase(TPropertyValue(slPropertyValues[i]).sKey)=sKey) and
       (LowerCase(TPropertyValue(slPropertyValues[i]).sSection)=sSection) and
       (LowerCase(TPropertyValue(slPropertyValues[i]).sFile)=sFile) then
    begin
      Result:=TPropertyValue(slPropertyValues[i]);
      iRow:=i+1;
      break;
    end;
end;

procedure TfrmMain.InitChooseWhatToDo;
begin
  cmImageQuality2.Items:=cmImageQuality.Items;
  cmImageQuality2.ItemIndex:=iDEFAULT_QUALITY_INDEX;
end;

procedure TfrmMain.cmImageQuality2Change(Sender: TObject);
begin
  sQuality:=cmImageQuality2.Items[cmImageQuality.ItemIndex]
end;

procedure TfrmMain.cmImageQualityChange(Sender: TObject);
begin
  sQuality:=cmImageQuality.Items[cmImageQuality.ItemIndex]
end;

end.
